﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WarmlyShip
{
	internal class DrawningObjectShip : IDrawningObject
	{
		private DrawingWarmlyShip _warmlyShip = null;

		public DrawningObjectShip(DrawingWarmlyShip warmlyShip)
		{
			_warmlyShip = warmlyShip;
		}

		public float Step => _warmlyShip?.warmlyShip?.Step ?? 0;

		public void DrawningObject(Graphics g)
		{
			_warmlyShip?.DrawTransport(g);
		}

		public (float Left, float Right, float Top, float Bottom) GetCurrentPosition()
		{
			return _warmlyShip?.GetCurrentPosition() ?? default;
		}

		public void MoveObject(Direction direction)
		{
			_warmlyShip?.MoveTransport(direction);
		}

		public void SetObject(int x, int y, int width, int height)
		{
			_warmlyShip?.SetPosition(x, y, width, height);	
		}

		public string GetInfo() => _warmlyShip?.GetDataForSave();

		public static IDrawningObject Create(string data) => new DrawningObjectShip(data.CreateDrawningShip());
	}
}
